#include <iostream>
#include <fstream>
using namespace std;

const int N=500;
const int M=2000;
int n,m;

int a[N];
int x[M], y[M], b[M];

int main(int argc, char *argv[])
{
    std::ifstream inp(argv[1]);
    std::ifstream sol(argv[2]);
    std::ifstream out(argv[3]);

    if(!out.good())
      {
         cerr << "No competitor's output" << endl;
         cout << 0.0 << endl;
         return 0;
      }

    inp >> n >> m;
    for(int j=0;j<m;j++) inp >> x[j] >> y[j] >> b[j];
    for(int i=0;i<n;i++)
     {

    if(!out.good())
      {
         cerr << "Bad competitor's output" << endl;
         cout << 0.0 << endl;
         return 0;
      }
       out >> a[i];
      if(!out.good())
      {
         cerr << "Bad competitor's output" << endl;
         cout << 0.0 << endl;
         return 0;
      }
      if(a[i]<=0)
      {
         cerr << "Non positive values in competitor's output" << endl;
         cout << 0.0 << endl;
         return 0;
      }
     }

    for(int j=0;j<m;j++)
    {
      if(a[x[j]]+a[y[j]] != b[j])
      {
         cerr << "Error" << endl;
         cout << 0.0 << endl;
         return 0;
      }

    }

    cerr << "Correct answer" << endl;
    cout << 1.0 << endl;
    return 0;
}
